'use strict';

class Clock {
  constructor(maxDrift=10000) {
    this.lc = 0;
    this.maxDrift = maxDrift;
  }

  get now() { return this.lc; }
  get pt() { return Math.floor(Date.now() / 1000) * 1000; }

  drift(lc=this.lc, pt=this.pt) { return Math.max(lc, pt) - pt; }

  sync(lc=this.pt) {
    if (this.drift(lc) > this.maxDrift) { throw new Error('Clock Drift'); }
    return this.lc = Math.max(this.lc, lc);
  }

  tick(lc) { return this.sync(this.sync(lc) + 1); }
}

module.exports = Clock;
